/*-----------------------------------------------------
DLL pour appeler les fonctions API Windows suivantes:
    RegisterWindowMessage
    GlobalAddAtom
    GlobalDeleteAtom
permet de transmettre une chaine de caractres entre
deux applications
* ------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <tcl.h>
#include <tk.h>

 #if defined(__WIN32__)
 #   define WIN32_LEAN_AND_MEAN
 #   include <windows.h>
 #   undef WIN32_LEAN_AND_MEAN
 #   if defined(_MSC_VER)
 #       define EXPORT(a,b) __declspec(dllexport) a b
 #   else
 #       if defined(__BORLANDC__)
 #           define EXPORT(a,b) a _export b
 #       else
 #           define EXPORT(a,b) a b
 #       endif
 #   endif
 #else
 #   define EXPORT(a,b) a b
 #endif


EXPORT(int , Passechaine_Init)(Tcl_Interp *interp);
static int SMess (ClientData, Tcl_Interp*, int, char **);
int tcl_SMess( Tcl_Interp *);
static int RWMessage (ClientData, Tcl_Interp*, int, char **);
int tcl_RWMessage( Tcl_Interp *interp);
static int GDAtom (ClientData, Tcl_Interp*, int, char **);
int tcl_GDAtom( Tcl_Interp *interp);

//Variables globales
char nomfen [128];//nom de la fentre cible
UINT nummessage=0; //le numro du message  registrer
ATOM nAtom=0; //Atome reprsentant la chane transmise

/* point dentree de la librairie dynamique*/
/* interp est linterpreteur chargeant la dll */
EXPORT(int , Passechaine_Init)(Tcl_Interp *interp)
{

    /* creer les commandes lors du chargement de la librairie dynamique */
    tcl_SMess(interp);
    tcl_RWMessage(interp);
    tcl_GDAtom(interp);
    Tcl_PkgProvide(interp, "passechaine", "0.5");

    return TCL_OK;
}


/**************************************************/
/* Initialisation et envoi du message */

int
SMess (
	ClientData clientdata,/*inutile de sen soucier dans les cas simples*/
    Tcl_Interp* interp,   /*interpreteur chargeant la dll, inutile de linitialiser*/
    int argc,             /*nombre dargument de la commande Tcl*/
    char **argv           /*listes des arguments de la commande*/
    )
        
{


LPCSTR lachaine;//donnes  transmettre 
HWND handlecible;//fentre cible

	if ( argc != 3 )
	{
		Tcl_AppendResult(
			interp,
		    "nombre d\arguments incorrect. la syntaxe est : \"",
		    argv [0],
		    " Titre_fentre_cible donnees_chaine\"",
		   (char *) NULL
		);
		return TCL_ERROR;
	}
      
	  strcpy(nomfen, argv[1]);
	  strcpy(lachaine, argv[2]);
	  handlecible=FindWindow(NULL,nomfen);
	  if (handlecible==0) 
	  {
 		Tcl_AppendResult(
			interp,
		    "Pas de fentre du nom: ",
		    nomfen,
		   (char *) NULL
		);
      return TCL_ERROR;                              
   }
   	  nAtom=GlobalAddAtom(lachaine);
	  if (nAtom==0) 
	  {
 		Tcl_AppendResult(
			interp,
		    "Atome non cr",
		   (char *) NULL
		);
      return TCL_ERROR;                              
      }
	  if (nummessage==0) 
	  {
 		Tcl_AppendResult(
			interp,
		    "Num message non initialis",
		   (char *) NULL
		);
      return TCL_ERROR;                              
      }      
      
   SendMessage(handlecible, nummessage,nAtom,0);
	Tcl_AppendResult(
		interp,
		"La fentre ",
		nomfen,
		" a t trouve\n",
		"donnes ",
		lachaine,
		" transmises",
		(char *) NULL );

	return TCL_OK;
}
int
RWMessage (
	ClientData clientdata,
    Tcl_Interp* interp,   
    int argc,             
    char **argv          
    )
    
{
char messnum [9];   

	if ( argc != 2 )
	{
		Tcl_AppendResult(
			interp,
		    "nombre darguments incorrect. la syntaxe est : \"",
		    argv [0],
		    " Titre_fentre_cible donnees \"",
		   (char *) NULL
		);
		return TCL_ERROR;
	}
      nummessage= RegisterWindowMessage(argv[1]);
      if (nummessage==0) {
       		Tcl_AppendResult(
			interp,
		    "message non registr",
		    nomfen,
		   (char *) NULL
		);
      return TCL_ERROR;  
      }
      sprintf(messnum,"%d",nummessage);
     	Tcl_AppendResult(
			interp,
		    "numro de message: ",
		    messnum,
		   (char *) NULL );

	return TCL_OK;
}
/* on fait le mnage en sortant...*/
int
GDAtom (
	ClientData clientdata,
    Tcl_Interp* interp,   
    int argc,            
    char **argv          
    )
    
{
    	  if (nAtom==0) 
	  {
 		Tcl_AppendResult(
			interp,
		    "Atome non cr",
		   (char *) NULL
		);
      return TCL_ERROR;                              
      }
    if ( GlobalDeleteAtom(nAtom)!=0)
    {
     		Tcl_AppendResult(
			interp,
		    "Impossible d\'effacer l\' atome",
		   (char *) NULL
		);
    }
	return TCL_OK;    
    
}
        
int
tcl_SMess( Tcl_Interp *interp)
{
	if ( Tcl_CreateCommand(
		interp,/*interpreteur chargeant la dll, inutile de linitialiser*/
		"passeVariables",/*nom de la commande pour linterpreteur*/
		SMess,    /*fonction C a invoquer quand la commande est appelee*/
		NULL,             /*client data, inutile de sen soucier dans la majorite des cas*/
		NULL              /*fonction C a invoquer si la commande est detruite*/
	) == NULL )
	{
		return TCL_ERROR;
	}

	return TCL_OK;
}

int
tcl_RWMessage( Tcl_Interp *interp)
{
	if ( Tcl_CreateCommand(
		interp,
		"registreMessage",
		RWMessage,    
		NULL,            
		NULL            
	) == NULL )
	{
		return TCL_ERROR;
	}

	return TCL_OK;
}

int
tcl_GDAtom( Tcl_Interp *interp)
{
	if ( Tcl_CreateCommand(
		interp,
		"Nettoie",
		GDAtom,   
		NULL,            
		NULL             
	) == NULL )
	{
		return TCL_ERROR;
	}

	return TCL_OK;
}
